const Main = imports.ui.main;
const Config = imports.misc.config;
const Me = imports.misc.extensionUtils.getCurrentExtension();
const Panel = Me.imports.modules.panel;
const Log = Me.imports.modules.log;
var powerProfileIndicatorExtension = class powerProfileIndicatorExtension {
    constructor() {
        this.PowerProfileIndicatorInstance = null;
        this.profileClient = null;
        this.systemMenu = null;
    }
    enable() {
        this.systemMenu = this.getSystemMenu();
        if (typeof this.systemMenu == 'undefined') {
            Log.raw('init', 'system menu is not defined');
            return false;
        }
        if (this.systemMenu._powerProfiles) {
            this.PowerProfileIndicatorInstance = new Panel.powerProfileIndicator();
            if (this.systemMenu._power)
                this.systemMenu._indicators.remove_child(this.systemMenu._power);
            this.systemMenu._indicators.add_child(this.PowerProfileIndicatorInstance);
            if (this.systemMenu._power)
                this.systemMenu._indicators.add_child(this.systemMenu._power);
        }
    }
    disable() {
        var _a, _b;
        (_a = this.profileClient) === null || _a === void 0 ? void 0 : _a.stop();
        (_b = this.PowerProfileIndicatorInstance) === null || _b === void 0 ? void 0 : _b.destroy();
        this.PowerProfileIndicatorInstance = null;
    }
    getSystemMenu() {
        if (parseInt(Config.PACKAGE_VERSION) < 43) {
            return Main.panel.statusArea.aggregateMenu;
        }
        else {
            return Main.panel.statusArea.quickSettings;
        }
    }
}
function init() {
    ext = new powerProfileIndicatorExtension();
    return ext;
}
//# sourceMappingURL=extension.js.map